<div class="catalogs-container">
  <section class="pageheadsection mob-pageheadsection1">
    <div class="mdl-grid mdl-grid.mdl-grid--no-spacing">
      <div>
        <gp-headline [headlineTitle]="'Marketplace |'"></gp-headline>
        <div class="favorite-buttons-container" *ngIf="loginUserId">
          <button
            class="favorite-button"
            mat-raised-button
            [color]="!isOnMyFavoriteSelected ? 'primary' : ''"
            (click)="onAllCatalogsClick()"
          >
            All catalogs
          </button>
          <button
            class="favorite-button"
            mat-raised-button
            [color]="isOnMyFavoriteSelected ? 'primary' : ''"
            (click)="onMyFavoriteCatalogsClick()"
          >
            My favorite catalogs
          </button>
        </div>
      </div>
      <gp-breadcrumb-navigation
        [firstNavigationLabel]="{ label: 'Home' }"
        [secondNavigationLabel]="{ label: 'Marketplace', disabled: true }"
        (firstNavigationClicked)="onHomeClick()"
      ></gp-breadcrumb-navigation>
    </div>
  </section>
  <mat-sidenav-container>
    <mat-sidenav mode="side" opened>
      <gp-filters
        [tags]="tags"
        [categories]="categories"
        (selectedTagsChange)="handleSelectedTagsChange($event)"
        (selectedCategoriesChange)="handleSelectedCategoriesChange($event)"
        (searchValueChanged)="onSearchValueChanged($event)"
      ></gp-filters>
    </mat-sidenav>
    <mat-sidenav-content class="page-wrap">
      <main class="content-router-outlet">
        <div class="filters-container">
          <div class="total-items-container" *ngIf="!isLoading">
            @if (totalItems > 0) {
              <div class="total-items-text-container">
                <span class="showing-text"
                  >Showing -
                  <span class="total-items-text">
                    {{ calculateStartIndex() }} to {{ calculateEndIndex() }} of
                    {{ totalItems }} Models</span
                  ></span
                >
              </div>
            }
          </div>

          <div class="gp-sort-by" *ngIf="!isLoading">
            <gp-sort-by
              [sortByOptions]="sortByOptions"
              [selectedSortBy]="sortByFilter"
              (sortBySelected)="updateFieldToDirectionMap($event)"
            ></gp-sort-by>
          </div>
          <div class="gp-card-list-view" *ngIf="!isLoading">
            <gp-solutions-toggle-view
              [viewTile]="viewTile"
              (viewTileChange)="onViewTileChange($event)"
            ></gp-solutions-toggle-view>
          </div>
        </div>
        <ng-container *ngIf="publicSolutions && !isLoading; else loadingState">
          <ng-container *ngIf="publicSolutions.length > 0; else noCatalogs">
            <div *ngIf="!viewTile; else gridView">
              <!-- Horizontal list view content -->
              <div class="grid-list">
                <gp-list-item
                  [item]="item"
                  [items]="publicSolutions"
                  [isMarketPlacePage]="true"
                  [isPublishedSolution]="true"
                  *ngFor="let item of publicSolutions"
                ></gp-list-item>
              </div>
            </div>
            <ng-template #gridView>
              <div class="grid-list">
                <mat-grid-list cols="5" rowHeight="3:4" gutterSize="20px">
                  <mat-grid-tile *ngFor="let item of publicSolutions">
                    <div class="cards-container">
                      <gp-card-item
                        [isPublishedSolution]="true"
                        [item]="item"
                        [items]="publicSolutions"
                        [isMarketPlacePage]="true"
                        [isFavoriteSolution]="
                          favoriteSolutionsMap[item.solutionId]
                        "
                        (favoriteClicked)="updateFavorite(item.solutionId)"
                      ></gp-card-item>
                    </div>
                  </mat-grid-tile>
                </mat-grid-list>
              </div>
            </ng-template>
          </ng-container>
          <ng-template #noCatalogs>
            <div class="loading-data">
              <p>No result found...</p>
            </div>
          </ng-template>
        </ng-container>
        <ng-template #loadingState>
          <div class="loading-data">
            <p>Loading data ...</p>
          </div>
        </ng-template>
        @if (totalItems > 0) {
          <mat-paginator
            [length]="totalItems"
            [pageSize]="pageSize"
            [pageSizeOptions]="pageSizeOptions"
            (page)="onPageChange($event)"
            aria-label="Select page"
            aria-label="Select page"
          >
          </mat-paginator>
        }</main></mat-sidenav-content
  ></mat-sidenav-container>
</div>
